/*
 * Word counter, generation 1
 * Jari Komppa 1999
 *
 * extremely naive implementation
 */

#include "wc.cpp"

typedef struct itemstruct {
  itemstruct * next;
  char * data;
  int hits;
} ITEM;

ITEM * root;

void init_gen(void)
{
  root=NULL;
}

typedef struct insertSortList {
	insertSortList * next;
	char * data;
	int hits;
} SORTITEM;

SORTITEM * sroot;

void insert_sort(ITEM * i) {
	SORTITEM * n;
	n=(SORTITEM*)malloc(sizeof(SORTITEM));
	n->data=i->data;
	n->hits=i->hits;
	n->next=NULL;
	if (sroot==NULL) {
		sroot=n;
		return;
	}
	if (sroot->hits<n->hits) {
		n->next=sroot;
		sroot=n;
		return;
	}
	SORTITEM * r=sroot, * l=sroot;
	while (r->hits>=n->hits && r->next!=NULL) {
		l=r;
		r=r->next;
	}
	if (r->next==NULL) {
		l=r;
	}
	n->next=l->next;
	l->next=n;
}

void traverse(ITEM * i) {	
	insert_sort(i);
	if (i->next!=NULL) traverse(i->next);
}

void report(void)
{
	printf("Generating report..\n");
	traverse(root);
	SORTITEM *i=sroot;
	FILE * f;
	f=fopen("output.txt","wb");
	while (i!=NULL) {
		fprintf(f,"%8i %s\r\n",i->hits,i->data);
		i=i->next;
	}
	fclose(f);
}

int insert_word(char * new_word)
{
  if (new_word==NULL) return 0;
  ITEM * item;
  item=root;
  while (item!=NULL) {
    if (strcmp(item->data,new_word)==0) {
      item->hits++;
      return 1;
    }
    item=item->next;
  }
  item=(ITEM*)malloc(sizeof(ITEM));
  item->next=root;
  item->data=strdup(new_word);
  item->hits=1;
  root=item;
  return 1;
}
