/*
 * Word counter, generation 2
 * Jari Komppa 1999
 *
 * - checksum ("hash") values included
 */

#include "wc.cpp"

typedef struct itemstruct {
  itemstruct * next;
  char * data;
  int hits;
  int hash;
} ITEM;

int hash(char * str) {
  char * p;
  int h,t;
  h=0;
  p=str;
  while (*p) {
    t=h>>(32-5);
    h<<=5;
    h+=t; // rol 5
    h+=*p;
    p++;
  }
  return h;
}

ITEM * root;

void init_gen(void)
{
  root=NULL;
}

void traverse(ITEM * i) {	
	insert_sort(i);
	if (i->next!=NULL) traverse(i->next);
}

void report(void)
{
	printf("Generating report..\n");
	traverse(root);
	SORTITEM *i=sroot;
	FILE * f;
	f=fopen("output.txt","wb");
	while (i!=NULL) {
		fprintf(f,"%8i %s\r\n",i->hits,i->data);
		i=i->next;
	}
	fclose(f);
}
int insert_word(char * new_word)
{
  if (new_word==NULL) return 0;
  int newhash=hash(new_word);
  ITEM * item;
  item=root;
  while (item!=NULL) {
    if (newhash==item->hash)
      if (strcmp(item->data,new_word)==0) {
        item->hits++;
        return 1;
      }
    item=item->next;
  }
  item=(ITEM*)malloc(sizeof(ITEM));
  item->next=root;
  item->data=strdup(new_word);
  item->hits=1;
  item->hash=newhash;
  root=item;
  return 1;
}
